﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication36
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            for (int i = 0; i < 100; i++)
            {
                this.ultraDataSource1.Rows.Add(new object[] { "Row " + i.ToString(), "Group" + (i % 5).ToString(), i });
            }
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridLayout layout = e.Layout;
            UltraGridBand band = layout.Bands[0];

            layout.ViewStyleBand = ViewStyleBand.OutlookGroupBy;

            UltraGridColumn groupColumn = band.Columns["Group"];
            band.SortedColumns.Add(groupColumn, false, true);

            UltraGridColumn valueColumn = band.Columns["Value"];
            band.Summaries.Add("ValueSummary", SummaryType.Sum, valueColumn);

            band.Summaries.Add("ProportionalSummary", SummaryType.External, valueColumn);
            
        }

        private void ultraGrid1_ExternalSummaryValueRequested(object sender, ExternalSummaryValueEventArgs e)
        {
            if (e.SummaryValue.Key == "ProportionalSummary")
            {
                // Get the summary of this group. 
                decimal groupSum = (decimal)e.SummaryValue.ParentRows.SummaryValues["ValueSummary"].Value;

                // Get the grand total. Even though it's not visible, you can still get the 
                // grand total summary from the root-level rows collection.                 
                decimal grandtotal = (decimal)e.SummaryValue.ParentRows.Band.Layout.Rows.SummaryValues["ValueSummary"].Value;

                // Calculated the proportionalSummary and set it. 
                var proportionalSummary = (decimal)groupSum / (decimal)grandtotal;
                e.SummaryValue.SetExternalSummaryValue(proportionalSummary.ToString("g2"));
            }
        }
    }
}
